JUCE: CameraDevice Class Reference

JUCE

Classes | Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
CameraDevice Class Reference
juce_video » capture

Controls any video capture devices that might be available. More...

`#include <juce_CameraDevice.h>`

## Classes
class | Listener
| Receives callbacks with individual frames from a CameraDevice. More...

## Public Types
using | OpenCameraResultCallback = std::function< void(CameraDevice *, const String &)>

## Public Member Functions
virtual | ~CameraDevice ()
| Destructor. More...
const String & | getName () const noexcept
| Returns the name of this device. More...
Component * | createViewerComponent ()
| Creates a component that can be used to display a preview of the video from this camera. More...
void | takeStillPicture (std::function< void(const Image &)> pictureTakenCallback)
| Triggers a still picture capture. More...
void | startRecordingToFile (const File &file, int quality=2)
| Starts recording video to the specified file. More...
void | stopRecording ()
| Stops recording, after a call to startRecordingToFile(). More...
Time | getTimeOfFirstRecordedFrame () const
| After calling stopRecording(), this method can be called to return the timestamp of the first frame that was written to the file. More...
void | addListener (Listener *listenerToAdd)
| Adds a listener to receive images from the camera. More...
void | removeListener (Listener *listenerToRemove)
| Removes a listener that was previously added with addListener(). More...

## Static Public Member Functions
static StringArray | getAvailableDevices ()
| Returns a list of the available cameras on this machine. More...
static CameraDevice * | openDevice (int deviceIndex, int minWidth=128, int minHeight=64, int maxWidth=1024, int maxHeight=768, bool highQuality=true)
| Synchronously opens a camera device. More...
static void | openDeviceAsync (int deviceIndex, OpenCameraResultCallback resultCallback, int minWidth=128, int minHeight=64, int maxWidth=1024, int maxHeight=768, bool highQuality=true)
| Asynchronously opens a camera device on iOS (iOS 7+) or Android (API 21+). More...
static String | getFileExtension ()
| Returns the file extension that should be used for the files that you pass to startRecordingToFile(). More...

## Public Attributes
std::function< void(const String &)> | onErrorOccurred
| Set this callback to be notified whenever an error occurs. More...

## Detailed Description

Controls any video capture devices that might be available.

Use getAvailableDevices() to list the devices that are attached to the system, then call openDevice() or openDeviceAsync() to open one for use. Once you have a CameraDevice object, you can get a viewer component from it, and use its methods to stream to a file or capture still-frames.

## Member Typedef Documentation

## ◆ OpenCameraResultCallback

using CameraDevice::OpenCameraResultCallback = std::function<void (CameraDevice*, const String& )>

## Constructor & Destructor Documentation

## ◆ ~CameraDevice()

virtual CameraDevice::~CameraDevice | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ getAvailableDevices()

static StringArray CameraDevice::getAvailableDevices | ( |  | ) |
| static

Returns a list of the available cameras on this machine.

You can open one of these devices by calling openDevice() or openDeviceAsync().

## ◆ openDevice()

static CameraDevice * CameraDevice::openDevice | ( | int | deviceIndex,
|  | int | minWidth = `128`,
|  | int | minHeight = `64`,
|  | int | maxWidth = `1024`,
|  | int | maxHeight = `768`,
|  | bool | highQuality = `true`
| ) |  |
| static

Synchronously opens a camera device.

This function should not be used on iOS or Android, use openDeviceAsync() instead.

The index parameter indicates which of the items returned by getAvailableDevices() to open.

The size constraints allow the method to choose between different resolutions if the camera supports this. If the resolution can't be specified (e.g. on the Mac) then these will be ignored.

On Mac, if highQuality is false, then the camera will be opened in preview mode which will allow the OS to drop frames if the computer cannot keep up in processing the frames.

## ◆ openDeviceAsync()

static void CameraDevice::openDeviceAsync | ( | int | deviceIndex,
|  | OpenCameraResultCallback | resultCallback,
|  | int | minWidth = `128`,
|  | int | minHeight = `64`,
|  | int | maxWidth = `1024`,
|  | int | maxHeight = `768`,
|  | bool | highQuality = `true`
| ) |  |
| static

Asynchronously opens a camera device on iOS (iOS 7+) or Android (API 21+).

On other platforms, the function will simply call openDevice(). Upon completion, resultCallback will be invoked with valid CameraDevice* and an empty error String on success, or nullptr CameraDevice and a non-empty error String on failure.

This is the preferred method of opening a camera device, because it works on all platforms, whereas synchronous openDevice() does not work on iOS & Android.

The index parameter indicates which of the items returned by getAvailableDevices() to open.

The size constraints allow the method to choose between different resolutions if the camera supports this. If the resolution can't be specified then these will be ignored.

On iOS, if you want to switch a device, it is more efficient to open a new device before closing the older one, because this way both devices can share the same underlying camera session. Otherwise, the session needs to be close first, and this is a lengthy process that can take several seconds.

The Android implementation currently supports a maximum recording resolution of 1080p. Choosing a larger size will result in larger pictures taken, but the video will be capped at 1080p.

## ◆ getName()

const String & CameraDevice::getName | ( |  | ) | const
| noexcept

Returns the name of this device.

References gl::name.

## ◆ createViewerComponent()

Component * CameraDevice::createViewerComponent | ( |  | ) |

Creates a component that can be used to display a preview of the video from this camera.

Note: While you can change the size of the preview component, the actual preview display may be smaller than the size requested, because the correct aspect ratio is maintained automatically.

## ◆ takeStillPicture()

void CameraDevice::takeStillPicture | ( | std::function< void(const Image &)> | pictureTakenCallback | ) |

Triggers a still picture capture.

Upon completion, pictureTakenCallback will be invoked on a message thread.

On Android, before calling takeStillPicture(), you need to create a preview with createViewerComponent() and you need to make it visible on screen.

Android does not support simultaneous video recording and still picture capture.

## ◆ startRecordingToFile()

void CameraDevice::startRecordingToFile | ( | const File & | file,
|  | int | quality = `2`
| ) |  |

Starts recording video to the specified file.

You should use getFileExtension() to find out the correct extension to use for your filename.

If the file exists, it will be deleted before the recording starts.

This method may not start recording instantly, so if you need to know the exact time at which the file begins, you can call getTimeOfFirstRecordedFrame() after the recording has finished.

The quality parameter can be 0, 1, or 2, to indicate low, medium, or high. It may or may not be used, depending on the driver.

On Android, before calling startRecordingToFile(), you need to create a preview with createViewerComponent() and you need to make it visible on screen.

The Android camera also requires exclusive access to the audio device, so make sure you close any open audio devices with AudioDeviceManager::closeAudioDevice() first.

Android does not support simultaneous video recording and still picture capture.

See also
  AudioDeviceManager::closeAudioDevice, AudioDeviceManager::restartLastAudioDevice

## ◆ stopRecording()

void CameraDevice::stopRecording | ( |  | ) |

Stops recording, after a call to startRecordingToFile().

## ◆ getFileExtension()

static String CameraDevice::getFileExtension | ( |  | ) |
| static

Returns the file extension that should be used for the files that you pass to startRecordingToFile().

This may be platform-specific, e.g. ".mov" or ".avi".

## ◆ getTimeOfFirstRecordedFrame()

Time CameraDevice::getTimeOfFirstRecordedFrame | ( |  | ) | const

After calling stopRecording(), this method can be called to return the timestamp of the first frame that was written to the file.

## ◆ addListener()

void CameraDevice::addListener | ( | Listener * | listenerToAdd | ) |

Adds a listener to receive images from the camera.

Be very careful not to delete the listener without first removing it by calling removeListener().

## ◆ removeListener()

void CameraDevice::removeListener | ( | Listener * | listenerToRemove | ) |

Removes a listener that was previously added with addListener().

## Member Data Documentation

## ◆ onErrorOccurred

std::function<void (const String& )> CameraDevice::onErrorOccurred

Set this callback to be notified whenever an error occurs.

You may need to close and reopen the device to be able to use it further.

The documentation for this class was generated from the following file:

- juce_CameraDevice.h